#pragma once

#include <hilbert/kernel/framebuffer.hpp>
#include <hilbert/kernel/utility.hpp>
#include <stddef.h>
#include <stdint.h>

namespace hilbert::kernel::terminal {

  extern uint8_t *termfont;
  extern uint64_t termfont_len;

  void init_terminal();

  extern int width;
  extern int height;

  extern int cursor_x;
  extern int cursor_y;

  extern framebuffer::color bg_color;
  extern framebuffer::color fg_color;

  void put_char(char ch);
  void put_string(const utility::string &str);
  void put_string_sz(const char *str);

  void put_int_decimal(uint64_t n, bool with_commas = true);

  void put_int_hex(uint64_t n, int digits, bool with_dots = true);

}
